
function [deriv]=deriv4thorder(nz,dz,f,order);

if order ==1 
    % j=1
    deriv(1) = -25/12*f(1) + 4*f(2) -3*f(3) + 4/3*f(4) - 1/4*f(5);
    % j=nz
    deriv(nz) = 25/12*f(nz) - 4*f(nz-1) +3*f(nz-2) - 4/3*f(nz-3) + 1/4*f(nz-4);
    % j=2
    deriv(2) = -1/4*f(1) - 5/6*f(2) + 3/2*f(3) -0.5*f(4) + 1/12*f(5);
    % j=nz-1
    deriv(nz-1) = 1/4*f(nz) + 5/6*f(nz-1) - 3/2*f(nz-2) + 0.5*f(nz-3) - 1/12*f(nz-4);
    % j between
    for j=3:nz-2
        deriv(j) = 1/12*f(j-2) -2/3*f(j-1) +2/3*f(j+1) - 1/12*f(j+2);
    end
    deriv=deriv/dz;
end

if order ==2
    % j=1
    deriv(1) = 45/12*f(1) - 77/6*f(2) + 107/6*f(3) - 13*f(4) + 61/12*f(5) - 5/6*f(6);
    % j=nz
    deriv(nz) = 45/12*f(nz) - 77/6*f(nz-1) + 107/6*f(nz-2) - 13*f(nz-3) + 61/12*f(nz-4) - 5/6*f(nz-5);
    % j=2
    deriv(2) = 5/6*f(1) - 5/4*f(2) - 1/3*f(3) + 7/6*f(4) - 1/2*f(5) + 1/12*f(6);
    % j=nz-1
    deriv(nz-1) =  5/6*f(nz) - 5/4*f(nz-1) - 1/3*f(nz-2) + 7/6*f(nz-3) - 1/2*f(nz-4) +1/12*f(nz-5);
    % j between
    for j=3:nz-2
        deriv(j) = -1/12*f(j-2) + 4/3*f(j-1) -5/2*f(j) + 4/3*f(j+1) - 1/12*f(j+2);
    end
    deriv=deriv/dz^2;
end
return

