% Matlab script to create 2D plot of Nu and f
% This is a self-stanidng code
% Wenrong Cao, 2018-10-1

Nu = 1.0001:0.1:9.0001; % Nusselt number at surface
f  = 0:0.01:1;          % thickness faction of hydrothermal layer
lambda0 = 3;            % normal thermal conductivity [W/m/K]

% visulize result
figure(1)
clf 
[NU,F]=meshgrid(Nu,f);
LAMBAR = lambda0.*(((NU-1)./Nu).*(1./log(NU)).*F+(1-F)).^(-1); % effective conductivity
gamma = LAMBAR ./ lambda0;     % calculate the ratio: gamma
contour(NU,F,LAMBAR./3,'LineWidth',2,'LevelStep',0.1,'ShowText','on');

grid on
colorbar
ylabel ('f','FontSize',18);
xlabel ('Nu','FontSize',18);
 xlim([1, 9]);
 ylim([0, 1]);
 c=colorbar;
 caxis([3/3 2.5]);
%optional choice to save the result as a pdf file
%saveas(gcf,'Nufplot', 'pdf')
